#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <clocale>

using namespace std;
#include "console.h"
#include "random.h"


struct TVersenyzo {
    // a versenyz meznek sorszma
    int mez;
    // a versenyz meznek szne
    Console::Color szin;
    // a versenyz pozcija a plyn
    int helyzet;
    // az elz helyzet trlshez
    string szokozok;
};

const int maxLepes = 6;
// vrakozs ezredmsodpercben a lpsek kztt
const int szunet = 500;
// a plya hossza
int hossz;
const int minMagassag = 35;  // az ablak minimlis magassga (sor)

Console::Color szinek[] = { Console::Gray,  Console::Green, Console::Cyan, Console::Red,
                            Console::Magenta, Console::Yellow, Console::White};
int szinekSzama = sizeof(szinek)/sizeof(Console::Color);

Random velszam;
// a versenyzk szma
int versenyzokSzama;

vector<int> gyoztesek;
TVersenyzo* versenyzok;

void VersenyzoLetrehoz(TVersenyzo *, int);
void PalyaLetrehoz(int);
void Futas();
void Eredmeny();
void Fut(TVersenyzo *);
void Kiir(TVersenyzo *);

void Start()
{
    Console::SetTitle("Futverseny");

        // Beolvassuk a versenyzk szmt:
    int szam;
    do {
        cout << "A versenyzk szma (<" << Console::GetLargestWindowHeight()-5  << "): ";
        cin >> szam; cin.get();
    } while (szam<= 0 || szam >= Console::GetLargestWindowHeight()-5);
    versenyzokSzama = szam;

     // Mretezzk a versenyzket tartalmaz tmbt s rtket adunk a versenyzk tulajdonsgainak:
    versenyzok = new TVersenyzo[versenyzokSzama + 1];
    for (int i = 1; i <= versenyzokSzama; i++)
    {
        VersenyzoLetrehoz(&versenyzok[i], i);
    }

    // Kirajzoljuk a plyt:
    PalyaLetrehoz(versenyzokSzama);
    // Elindtjuk a versenyt:
    Futas();
    // Kirjuk a gyzteseket:
    Eredmeny();
    cout<<"(Enter: kilp)"<<endl;
    cin.get();
}

void VersenyzoLetrehoz(TVersenyzo *pversenyzo, int sorszam)
{
    pversenyzo->mez = sorszam;
    pversenyzo->szin = szinek[velszam.Next(0, szinekSzama)];
    pversenyzo->helyzet = 0;
    // a szmjegyek szmval megegyez szm szkz a trlshez
    pversenyzo->szokozok.append(log10(pversenyzo->mez)+1, ' ');
}

void PalyaLetrehoz(int versenyzokSzama)
{
	hossz = Console::GetWindowWidth()-10;
    // Az ablak mretnek mdostsa:
    int magassag = versenyzokSzama + 5;
    if (magassag < minMagassag)
          magassag = minMagassag;
    Console::SetSize(hossz+10, magassag);
    // A clvonal kirajzolsa:
    Console::ClearConsole();
    Console::SetTitle("Futverseny");
    Console::SetForegroundColor(Console::Yellow);
    for (int i=1; i<=versenyzokSzama; i++) {
        Console::SetCursorPosition(hossz,i-1);
        cout << "|";
    }
    Console::SetForegroundColor(Console::White);
}

void Futas()
{
    do
    {
        Console::SetCursorPosition(0,0);
        for (int i = 1; i <= versenyzokSzama; i++)
        {
            Fut(&versenyzok[i]);
        }
        Sleep(szunet);
    } while (gyoztesek.size() == 0);
    Console::SetForegroundColor(Console::Gray);
    cout << endl << "Vge a versenynek." << endl;
}

void Eredmeny()
{
    cout << "Gyztt: ";
    for (unsigned int i=0; i < gyoztesek.size(); i++)
        cout << gyoztesek.at(i) << " ";
    cout << endl;
}

void Fut(TVersenyzo *pversenyzo)
{
    // Letrljk az elz helyet:
    Console::SetCursorPosition(pversenyzo->helyzet, pversenyzo->mez-1);
    cout << pversenyzo->szokozok;
    // letrljk az elz helyet
    pversenyzo->helyzet += velszam.Next(1, maxLepes + 1);
    // a versenyz bert a clba
    if (pversenyzo->helyzet >= hossz)
    {
        gyoztesek.push_back(pversenyzo->mez);
        // Trljk a clvonalat a versenyz sorban:
        Console::SetCursorPosition(hossz, pversenyzo->mez-1);
        cout << " ";
    }
    Kiir(pversenyzo);
}

void Kiir(TVersenyzo *pversenyzo)
{
    // Megjelentjk a versenyz helyt:
    Console::SetCursorPosition(pversenyzo->helyzet, pversenyzo->mez-1);
    Console::SetForegroundColor(pversenyzo->szin);
    cout << pversenyzo->mez;
}

int main()
{
    setlocale(LC_ALL,"Hun");
    Start();
}
