// A konzolablak kezelst vgz fggvnyek

#include <windows.h>
#include "console.h"

// A kurzor pozcijnak belltsa
void Console::SetCursorPosition(int x, int y)
{
     COORD coord = { x, y };
     // Az aktulis output puffer leirja
     HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
     SetConsoleCursorPosition(hStdOut, coord);
     return;
}

// A konzolablak tartalmnak trlse
void Console::ClearConsole()
{
     HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
     COORD coord = {0, 0};
     DWORD count;
     CONSOLE_SCREEN_BUFFER_INFO csbi;
     // A konzol pufferinformciinak lekrdezse
     if(GetConsoleScreenBufferInfo(hStdOut, &csbi))
     {
          // A puffer feltltse szkzkkel s alap atribtumokkal
          FillConsoleOutputCharacter(hStdOut, (char) 32, csbi.dwSize.X * csbi.dwSize.Y, coord, &count);
          FillConsoleOutputAttribute(hStdOut, csbi.wAttributes, csbi.dwSize.X * csbi.dwSize.Y, coord, &count );
          // A kurzor pozicionlsa a bal fels sarokba
          SetConsoleCursorPosition(hStdOut, coord);
     }
     return;
}

// A karakterszn belltsa
void Console::SetForegroundColor(int color)
{
     WORD wColor;
     HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
     CONSOLE_SCREEN_BUFFER_INFO csbi;
     if(GetConsoleScreenBufferInfo(hStdOut, &csbi))
     {
         // A betszn s a httrszn sszeptse
          wColor = (csbi.wAttributes & 0xF0) + (color & 0x0F);
          SetConsoleTextAttribute(hStdOut, wColor);
     }
     return;
}

// A kozolablak tmretezse
void Console::SetSize(int width, int height)
{
    SMALL_RECT r;
    COORD c;
    HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);

    r.Left = 0;
    r.Top = 0;
    r.Right = width - 1;
    r.Bottom = height - 1;
    SetConsoleWindowInfo(hStdOut, TRUE, &r);
    c.X = width;
    c.Y = height;
    SetConsoleScreenBufferSize(hStdOut, c);

	CONSOLE_SCREEN_BUFFER_INFO csbi;
	GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE), &csbi);
	r.Left = r.Top = 0;
	r.Right = min(csbi.dwMaximumWindowSize.X, csbi.dwSize.X) - 1;
	r.Bottom = min(csbi.dwMaximumWindowSize.Y, csbi.dwSize.Y) - 1;
	SetConsoleWindowInfo(GetStdHandle(STD_OUTPUT_HANDLE), true, &r);
}

// A kozolablak maximlis magassga
int Console::GetLargestWindowHeight()
{
    COORD c;
    HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
    c =  GetLargestConsoleWindowSize(hStdOut)  ;
    return c.Y;
}

// A kozolablak maximlis szlessge
int Console::GetLargestWindowWidth()
{
    COORD c;
    HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
    c =  GetLargestConsoleWindowSize(hStdOut)  ;
    return c.X;
}

// A kozolablak aktulis szlessge
int Console::GetWindowWidth()
{
    HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	GetConsoleScreenBufferInfo(hStdOut, &csbi);
	return csbi.dwSize.X;
}

// A kozolablak aktulis magassga
int Console::GetWindowHeight()
{
    HANDLE hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	GetConsoleScreenBufferInfo(hStdOut, &csbi);
	return csbi.dwSize.Y;
}

// A konzolablak fejlce
void Console::SetTitle(const char * title)
{
    char tmp[81];
    AnsiToOem(title, tmp);
    SetConsoleTitle(tmp);
}

// Adott virtulis billentykd (VK_ESCAPE, VK_RETURN, VK_SPACE, VK_A, ...) billenty tesztelse
bool Console::KeyPressed(int vkey)
{
    return (GetAsyncKeyState(vkey) & 0x8000U) != 0;
}

// zenetablak megjelentse
void Console::MsgBox(const char *title, const char *message)
{
    MessageBox(NULL, title, message, MB_OK);
}

// A konzol input puffer trlse
void Console::ClearInputBuffer()
{
    HANDLE hStdIn = GetStdHandle(STD_INPUT_HANDLE);
    FlushConsoleInputBuffer(hStdIn);
}
