﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace gy5
{
    public class TVerseny
    {
        // várakozás ezredmásodpercben a lépések között
        private const int szünet = 500;
        public TPálya pálya;
        public SortedSet<int> győztesek;
        // a versenyzők száma
        private int versenyzőkSzáma;
        private TVersenyző[] versenyzők;

        public void Start()
        {
            Console.Title = "Futóverseny";
            // Beolvassuk a versenyzők számát:
            Console.Write("A versenyzők száma (<" + (Console.LargestWindowHeight - 9).ToString() + "): ");
            versenyzőkSzáma = Convert.ToInt32(Console.ReadLine());
            // Méretezzük a versenyzőket tartalmazó tömböt és létrehozzuk a versenyzőobjektumokat (tömbelemek):
            versenyzők = new TVersenyző[versenyzőkSzáma + 1];
            for (int i = 1; i <= versenyzőkSzáma; i++)
            {
                versenyzők[i] = new TVersenyző(i);
            }

            // Létrehozzuk a pályaobjektumot:
            pálya = new TPálya(versenyzőkSzáma);

            // Elindítjuk a versenyt:
            győztesek = new SortedSet<int>();
            Futás();
            // Kiírjuk a győzteseket:
            Eredmény();

            // A Pálya objektumra mutató hivatkozás törlése:
            pálya = null;
            // A szemétgyűjtés indítása:
            GC.Collect();

            Console.Write("(Enter: kilép)");
            Console.ReadLine();
        }

        private void Futás()
        {
            do
            {
                Console.CursorTop = 0;
                for (int i = 1; i <= versenyzőkSzáma; i++)
                {
                    versenyzők[i].Fut(this);
                }
                Vár(szünet);
            } while (győztesek.Count == 0);
            Console.ForegroundColor = ConsoleColor.Gray;
            Console.WriteLine("Vége a versenynek.");
        }

        private void Eredmény()
        {
            Console.Write("Győzött: ");
            foreach (int elem in győztesek)
            {
                Console.Write(elem + " ");
            }
            Console.WriteLine();
        }

        private void Vár(int Időtartam)
        {
            System.Threading.Thread.Sleep(Időtartam);
        }
    }

}
