#include <iostream>
#include <clocale>
using namespace std;
#include "TObject.h"
#include "TSikidom.h"
#include "TTeglalap.h"
#include "TEllipszis.h"
#include "Random.h"

int main()
{
    setlocale(LC_ALL,"Hun");
    typedef TObject *PObject;

	PObject *sikidom = new PObject[10];
	TTeglalap *teglalap;
	TEllipszis *ellipszis;
	Random velszam;

	for (int i = 0; i < 10; i++) {
		switch (velszam.Next(1, 5)) {
			case 1:
				sikidom[i] = new TKor(0, 0, velszam.Next(1, 10));
				break;
			case 2:
				sikidom[i] = new TEllipszis(0, 0, velszam.Next(1, 10), velszam.Next(1, 10));
				break;
			case 3:
				sikidom[i] = new TNegyzet(0, 0, velszam.Next(1, 10));
				break;
			case 4:
				// vagy default:
				sikidom[i] = new TTeglalap(0, 0, velszam.Next(1, 10), velszam.Next(1, 10));
				break;
		}
	}

	for (int i = 0; i < 10; i++) {
		if (dynamic_cast<TEllipszis *>(sikidom[i])) {
		    // A C++ nem tamogatja a ksi kts dinamikus vltoztt:
			// cout << i << ". ellipszis lapultsga: " << sikidom[i]->Lapultsag() << endl;
		} else if (dynamic_cast<TTeglalap *>(sikidom[i])) {
		    // A C++ nem tamogatja a ksi kts dinamikus vltoztt:
			// cout << i << ". tglalap tlja: " << sikidom[i]->GetAtlo() << endl;
		}
	}

    cout << "A C++ nem tmogatja a ksi kts dinamikus vltozatt (lsd a forrskdot).";

	for (int i = 0; i < 10; i++) {
	    delete sikidom[i];
	}
	delete[] sikidom;
    cin.get();
}
