#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <clocale>
using namespace std;

const string ut  = "utkereses1.txt";  // az adatokat tartalmaz fjl elrsi tja
const char utch = '.';

struct TCella {
    bool fal;        // fal van-e a cella helyn
    bool jobbra, le; // szabad-e a megadott irnyba lpni a cellrl
    char honnan;     // honnan lptnk a cellra (f: fentrl, b: balrl)
};

vector < vector<TCella> > tabla;

int sordb, oszlopdb;

void Utkereses(int&, int&, bool&);
void Feltolt();
void Utkiir();
void Kiir();
void Megoldkiir();

int main()
{
    int sor = 1;
    int oszlop = 1;
    bool kesz = false;

    setlocale(LC_ALL,"Hun");

    Feltolt();
    Kiir();
    Utkereses(sor, oszlop, kesz);
    if (kesz) {
        Utkiir();
        Megoldkiir();
    }
    else
        cout << "Nincs megolds";

    cin.get();
    return 0;
}

void Utkereses(int& sor, int& oszlop, bool& kesz) { // tkeress itercival
    kesz = (sor == sordb && oszlop == oszlopdb);
    while (!kesz && sor >=1 && oszlop>=1) {
        // A kvetkez lps keresse:
        if (tabla[sor][oszlop].jobbra) { // jobbra lpnk
            tabla[sor][oszlop].jobbra = false;
            oszlop++;
            tabla[sor][oszlop].honnan = 'b';
        }
        else if (tabla[sor][oszlop].le) { // lefel lpnk
            tabla[sor][oszlop].le = false;
            sor++;
            tabla[sor][oszlop].honnan = 'f';
        }
        else { // visszalpnk
            if (!tabla[sor][oszlop+1].fal)
                tabla[sor][oszlop].jobbra = true;
            if (!tabla[sor+1][oszlop].fal)
                tabla[sor][oszlop].le = true;
            if (tabla[sor][oszlop].honnan == 'b') // balrl jttnk
                oszlop--;
            else // fentrl jttnk
                sor--;
        }
        kesz = (sor == sordb && oszlop == oszlopdb);
    }
}

void Feltolt() {
    ifstream fajl;
    string sor;

    fajl.open(ut.c_str());
    fajl >> sordb;  fajl.get();
    oszlopdb = sordb;

    //  A tbla dinamikus ellltsa: bels mret + 2 a szleknek
    tabla.resize(sordb+2);
    for (int i=0; i<sordb+2; i++)
       tabla[i].resize(oszlopdb+2);

    int i = 0;
    while (!fajl.eof()) {
        getline(fajl, sor);
        for (int j=0; j<sor.length(); j++) {
            switch (sor[j]) {
                case '.' : tabla[i+1][j+1].fal = false;
                           break;
                case 'x' : tabla[i+1][j+1].fal = true;
                           break;
            }
        }
        i++;
    }
    fajl.close();

    for (int i=1; i<=sordb; i++)
        for (int j=1; j<=oszlopdb; j++) {
            tabla[i][j].jobbra = (!tabla[i][j+1].fal);
            tabla[i][j].le = (!tabla[i+1][j].fal);
        }

    for (int i=0; i<sordb+2; i++) { // a szlek feltltse
        tabla[0][i].fal = true;
        tabla[sordb+1][i].fal = true;
        tabla[i][0].fal = true;
        tabla[i][oszlopdb+1].fal = true;
    }

    for (int i=1; i<=sordb; i++) {
        tabla[i][oszlopdb].jobbra = false;
        tabla[sordb][i].le = false;
    }
    // bejrat, kijrat:
    tabla[1][0].fal = false;
    tabla[sordb][oszlopdb+1].fal = false;

}

void Kiir() {
    for (int i=0; i<sordb+2; i++) {
        for (int j=0; j<oszlopdb+2; j++)
            if (tabla[i][j].fal)
                cout << "X";
            else
                cout << " ";
        cout << endl;
    }
    cout << endl;
}

void Utkiir() {
    string temp = "";
    int sor = sordb, oszlop = oszlopdb;

    while (!(sor == 1 && oszlop == 1))
        switch (tabla[sor][oszlop].honnan) {
            case 'b' : temp = "J" + temp; oszlop--; break;
            case 'f' : temp = "L" + temp; sor--; break;
        }
    cout << "Lpsek: " << temp << endl << endl;
}

void Megoldkiir() {
    // A honnan mezk alapjn feldertjk az utat
    char megold[sordb+2][oszlopdb+2];
/*    vector < vector<char> > megold(sordb+2) ; // alternatv megold tmb
      for (int i=0; i<sordb+2; i++)
          megold[i].resize(oszlopdb+2);
*/
    int i, j;

    for (i=0; i<sordb+2; i++)
        for (j=0; j<oszlopdb+2; j++)
            if (tabla[i][j].fal)
                megold[i][j] = 'X';
            else
                megold[i][j] = ' ';
    i = sordb;
    j = oszlopdb;
    while (!(i==1 && j==1)) {
        megold[i][j] = utch;
        switch (tabla[i][j].honnan) {
            case 'b' : j-- ; break;
            case 'f' : i-- ; break;
        }
    }
    megold[i][j] = utch;
    for (i=0; i<sordb+2; i++) {
        for (j=0; j<oszlopdb+2; j++)
            cout << megold[i][j];
        cout << endl;
    }
}
