﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

// Kártyakeverés
// A képfájlokat először felvettük az erőforrások közé (Project/Properties/Resources/Add resource),
// majd a gy5.Properties.Resources.ResourceManager.GetObject() metódussal rendeltük hozzá a PictureBox Image tulajdonságához.
// (A számjeggyel kezdődő erőforrásnevek elé aláhúzásjel kerül.)

namespace gy5
{
    public partial class Form1 : Form
    {
        const int n = 52;
        const int szélesség = 71;
        Dictionary<int, int> lap;
        PictureBox[] kártya = new PictureBox[n];
        int k;

        Random vélszám = new Random();

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // Töröljük az előzőleg megjelenített lapokat.
            // (A Controls kollekció 0-2 indexű eleme a label1, a textBox1 és a button1, a többi töröljük.)
            for (int i = this.Controls.Count - 1; i>2 ; i--)
            {
                this.Controls.RemoveAt(i);
            }
         
            k = Convert.ToInt32(textBox1.Text);
            Oszt();
            Kiír();
            textBox1.Focus();
            textBox1.SelectAll();
        }

        public void Oszt()
        {
            int j = 0;

            lap.Clear();
            for (int i = 0; i < k; i++)
            {
                j = vélszám.Next(i, n);
                Csere(i, j);
            }
        }

        public void Csere(int i, int j)
        {
            int temp = 0;

            if (!lap.ContainsKey(i))
            {
                lap.Add(i, i);
            }
            if (!lap.ContainsKey(j))
            {
                lap.Add(j, j);
            }
            // Csere:
            temp = lap[i];
            lap[i] = lap[j];
            lap[j] = temp;
        }

        public void Kiír()
        {
            for (int i = 0; i < k; i++)
            {
                kártya[i].Image = gy5.Properties.Resources.ResourceManager.GetObject("_" + (lap[i]+1)) as Image;
                kártya[i].Left = (i+1) * (szélesség + 2) - 50;
                this.Controls.Add(kártya[i]);
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            lap = new Dictionary<int, int>();
            for (int i = 0; i < n; i++)
            {
                lap[i] = i;
            }
            for (int i = 0; i < n; i++)
            {
                kártya[i] = new PictureBox();
                kártya[i].SizeMode = PictureBoxSizeMode.AutoSize;
                kártya[i].Top = 60;
            }
        }
    }
}
