#include <iostream>
#include <iomanip>
#include <clocale>
#include <vector>
using namespace std;

void Feltolt();
void Keres();
void Kiir();
void Kiir2();

int cimlet[] = { 0, 1, 5, 10, 20, 25 };
const int cimletMeret = sizeof(cimlet)/sizeof(int);

// Felttelezzk, hogy klnbzek az rmk, s szerepel kzttk az 1-es (mindig legyen megolds)
int osszeg, meretI, meretJ;
vector < vector<char> > honnan;     // honnan rkeztnk az (i,j) cellba
vector < vector<int> > tablazat;    // tblzat a megolds meghatrozshoz

int main()
{
    setlocale(LC_ALL,"Hun");
    cout << "Kifizetsre kerl sszeg: ";
    cin >> osszeg; cin.get();
    Feltolt();
    Keres();
    Kiir();
    cin.get();
    return 0;
}

void Keres()
{
    int i, j, balra, felette;
    // A keress algoritmusa:
    for (i = 1; i < meretI; i++) {
        for (j = 1; j < meretJ; j++) {
            if (i < cimlet[j]) {
                tablazat[i][j] = tablazat[i][j - 1];
                honnan[i][j] = '<';
            } else {
                balra = tablazat[i][j - 1];
                felette = tablazat[i - cimlet[j]][j] + 1;
                if (balra < felette) {
                    tablazat[i][j] = balra;
                    honnan[i][j] = '<';
                } else {
                    tablazat[i][j] = felette;
                    honnan[i][j] = '^';
                }
            }
        }
    }
}

void Feltolt()
{
	// A tmbk feltltse
	int i, j;
	meretI = osszeg+1;
	meretJ = cimletMeret;
	tablazat.resize(meretI);
	honnan.resize(meretI);
	for (i=0; i < meretI; i++) {
        honnan[i].resize(meretJ);
        tablazat[i].resize(meretJ);
	}

	// 0. sor
	for (j = 0; j < meretJ; j++) {
		tablazat[0][j] = 0;
	}
	// 0. oszlop
	for (i = 0; i < meretI; i++) {
		tablazat[i][0] = i;
	}
	for (i = 0; i < meretI; i++) {
		for (j = 0; j < meretJ; j++) {
			honnan[i][j] = ' '                                                                                                                                                                                            ;
		}
	}
}

void Kiir()
{
	// Az eredmnyek kirsa
	int i, j;
	int* db = new int[meretJ];

	cout << "\nA szksges pnzrmk szma: " << tablazat[meretI-1][ meretJ-1] << endl;

	cout<< "\nMegolds:" << endl;;
	for (j = 0; j <meretJ; j++) {
		db[j] = 0;
	}
	i = meretI-1;
	j = meretJ-1;
	while (i >0 && j >0) {
		switch (honnan[i][j]) {
			case '^':
				db[j]++;
				i -= cimlet[j];
				break;
			case '<':
				j--;
				break;
		}
	}
	for (j = 0; j < meretJ; j++) {
		if (db[j] != 0) {
			cout<< setw(2) <<  db[j] <<" db " << cimlet[j] << " tallros" << endl;
		}
	}
	cout<< endl;
    cin.get();

	cout<< "A megoldshoz vezet tblzat:" << endl <<  "    ";
	for (j = 0; j < meretJ; j++) {
		cout<< setw(2)<<cimlet[j] << "  ";
	}
	cout<< endl;

	for (i = 0; i < meretI; i++) {
		cout<< setw(2)<< i << ": ";
		for (j = 0; j < meretJ; j++) {
            cout<< setw(2)<< tablazat[i][j] << "  ";
		}
		cout<<endl;
	}
	cout<< endl;

	cout<< "A honnan tblzat:" << endl << "    ";
	for (j = 0; j < meretJ; j++) {
		cout<< setw(2)<<cimlet[j] << "  ";
	}
	cout << endl;
	for (i = 0; i < meretI; i++) {
		cout<< setw(2)<< i << ":  ";
		for (j = 0; j < meretJ; j++) {
			cout<< honnan[i][j] << "   ";
		}
		cout<< endl;
	}
	cout<< endl;
	delete [] db;
}


